EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_CANVAS_GROUP_EVENT_MEMBER_ADDED =
   EFL_EVENT_DESCRIPTION("member,added");
EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_CANVAS_GROUP_EVENT_MEMBER_REMOVED =
   EFL_EVENT_DESCRIPTION("member,removed");

void _efl_canvas_group_group_need_recalculate_set(Eo *obj, Evas_Smart_Data *pd, Eina_Bool value);


static Eina_Error
__eolian_efl_canvas_group_group_need_recalculate_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_canvas_group_need_recalculate_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_group_need_recalculate_set, EFL_FUNC_CALL(value), Eina_Bool value);

Eina_Bool _efl_canvas_group_group_need_recalculate_get(const Eo *obj, Evas_Smart_Data *pd);


static Eina_Value
__eolian_efl_canvas_group_group_need_recalculate_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_canvas_group_need_recalculate_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_group_need_recalculate_get, Eina_Bool, 0);

void _efl_canvas_group_group_change(Eo *obj, Evas_Smart_Data *pd);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODY(efl_canvas_group_change);

void _efl_canvas_group_group_calculate(Eo *obj, Evas_Smart_Data *pd);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODY(efl_canvas_group_calculate);

Eina_Iterator *_efl_canvas_group_group_members_iterate(const Eo *obj, Evas_Smart_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_group_members_iterate, Eina_Iterator *, NULL);

void _efl_canvas_group_group_member_add(Eo *obj, Evas_Smart_Data *pd, Efl_Canvas_Object *sub_obj);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_group_member_add, EFL_FUNC_CALL(sub_obj), Efl_Canvas_Object *sub_obj);

void _efl_canvas_group_group_member_remove(Eo *obj, Evas_Smart_Data *pd, Efl_Canvas_Object *sub_obj);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_group_member_remove, EFL_FUNC_CALL(sub_obj), Efl_Canvas_Object *sub_obj);

Eina_Bool _efl_canvas_group_group_member_is(const Eo *obj, Evas_Smart_Data *pd, const Efl_Canvas_Object *sub_obj);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV_CONST(efl_canvas_group_member_is, Eina_Bool, 0, EFL_FUNC_CALL(sub_obj), const Efl_Canvas_Object *sub_obj);

const Efl_Canvas_Object *_efl_canvas_group_group_clipper_get(const Eo *obj, Evas_Smart_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_group_clipper_get, const Efl_Canvas_Object *, NULL);

Efl_Object *_efl_canvas_group_efl_object_constructor(Eo *obj, Evas_Smart_Data *pd);


void _efl_canvas_group_efl_object_destructor(Eo *obj, Evas_Smart_Data *pd);


void _efl_canvas_group_efl_object_debug_name_override(Eo *obj, Evas_Smart_Data *pd, Eina_Strbuf *sb);


void _efl_canvas_group_efl_gfx_color_color_set(Eo *obj, Evas_Smart_Data *pd, int r, int g, int b, int a);


void _efl_canvas_group_efl_gfx_entity_visible_set(Eo *obj, Evas_Smart_Data *pd, Eina_Bool v);


void _efl_canvas_group_efl_gfx_entity_position_set(Eo *obj, Evas_Smart_Data *pd, Eina_Position2D pos);


void _efl_canvas_group_efl_gfx_entity_size_set(Eo *obj, Evas_Smart_Data *pd, Eina_Size2D size);


void _efl_canvas_group_efl_gfx_filter_filter_program_set(Eo *obj, Evas_Smart_Data *pd, const char *code, const char *name);


void _efl_canvas_group_efl_canvas_object_clipper_set(Eo *obj, Evas_Smart_Data *pd, Efl_Canvas_Object *clipper);


void _efl_canvas_group_efl_canvas_object_no_render_set(Eo *obj, Evas_Smart_Data *pd, Eina_Bool enable);


void _efl_canvas_group_efl_canvas_object_paragraph_direction_set(Eo *obj, Evas_Smart_Data *pd, Efl_Text_Bidirectional_Type dir);


Efl_Text_Bidirectional_Type _efl_canvas_group_efl_canvas_object_paragraph_direction_get(const Eo *obj, Evas_Smart_Data *pd);


static Eina_Bool
_efl_canvas_group_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_CANVAS_GROUP_EXTRA_OPS
#define EFL_CANVAS_GROUP_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_canvas_group_need_recalculate_set, _efl_canvas_group_group_need_recalculate_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_need_recalculate_get, _efl_canvas_group_group_need_recalculate_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_change, _efl_canvas_group_group_change),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_calculate, _efl_canvas_group_group_calculate),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_members_iterate, _efl_canvas_group_group_members_iterate),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_member_add, _efl_canvas_group_group_member_add),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_member_remove, _efl_canvas_group_group_member_remove),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_member_is, _efl_canvas_group_group_member_is),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_clipper_get, _efl_canvas_group_group_clipper_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_canvas_group_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_canvas_group_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_debug_name_override, _efl_canvas_group_efl_object_debug_name_override),
      EFL_OBJECT_OP_FUNC(efl_gfx_color_set, _efl_canvas_group_efl_gfx_color_color_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_visible_set, _efl_canvas_group_efl_gfx_entity_visible_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_position_set, _efl_canvas_group_efl_gfx_entity_position_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_size_set, _efl_canvas_group_efl_gfx_entity_size_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_filter_program_set, _efl_canvas_group_efl_gfx_filter_filter_program_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_clipper_set, _efl_canvas_group_efl_canvas_object_clipper_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_no_render_set, _efl_canvas_group_efl_canvas_object_no_render_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_paragraph_direction_set, _efl_canvas_group_efl_canvas_object_paragraph_direction_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_paragraph_direction_get, _efl_canvas_group_efl_canvas_object_paragraph_direction_get),
      EFL_CANVAS_GROUP_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"group_need_recalculate", __eolian_efl_canvas_group_group_need_recalculate_set_reflect, __eolian_efl_canvas_group_group_need_recalculate_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_canvas_group_class_desc = {
   EO_VERSION,
   "Efl.Canvas.Group",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Evas_Smart_Data),
   _efl_canvas_group_class_initializer,
   _efl_canvas_group_class_constructor,
   _efl_canvas_group_class_destructor
};

EFL_DEFINE_CLASS(efl_canvas_group_class_get, &_efl_canvas_group_class_desc, EFL_CANVAS_OBJECT_CLASS, EFL_GFX_FILTER_INTERFACE, NULL);
